﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BioAPI;
using BioAPI.Data;
using System.IO;

namespace BFPArchive
{
    public class BFPArchiveImplemented: IBFP
    {
        private static UUID bfpUUID = new UUID(new Guid("db1d7ca9-1984-4ac8-a2fb-3d5c4e43304c"));
        private static string path = @"..\..\..\..\BFPArchive\bin\Debug\BFPArchive.dll";
        private static string pathBBDD = @"..\..\..\..\Templates";
        private BFPSchema bfpSchema = new BFPSchema(bfpUUID, UnitCategoryType.Archive, null, path, null, "BFPArchive 1.0", "GUTI", null, null, 
            null, null, null);
        private List<UnitSchema> unitlist = new List<UnitSchema>();
        private BBDDGuti gutiArchive = new BBDDGuti();

        public BFPSchema BFPSchema
        {
            get
            {
                return bfpSchema;
            }
        }

        public void BFPEventCallback(UUID bfpUUID, int unitID, UnitSchema unitSchema, EventKind eventKind)
        {

        }

        public void BFPGUIProgressEventCallback(int unitID, string context, List<GUIBitmap> bitmaps, byte response)
        {

        }

        public void UnitAttach(int unitID)
        {

        }

        public void UnitDetach(int unitID)
        {

        }

        public void BFPLoad(BFPEventCallback bfpNotifyCallback)
        {
            unitlist.Add(gutiArchive.UnitSchema);
        }

        public List<UnitSchema> QueryUnits()
        {
            return unitlist;
        }

        public byte[] ControlUnit(int unitID, int controlCode, byte[] inputData)
        {
            return null;
        }

        private static string CreateId()
        {
            string[] di = Directory.GetDirectories(pathBBDD);
            string id = null, finalpath = null;

            int max = 0;
            for (int i = 0; i < di.Length; i++)
            {
                if (int.Parse(di[i].Substring(di[i].Length - 4, 4)) > max)
                {
                    max = int.Parse(di[i].Substring(di[i].Length - 4, 4));
                }
            }
            max++;
            if (max < 10)
                id = "000" + max.ToString();
            if (max < 100 & max > 9)
                id = "00" + max.ToString();
            if (max < 1000 & max > 99)
                id = "0" + max.ToString();
            if (max >= 1000)
                id = max.ToString();
            Directory.CreateDirectory(pathBBDD + "\\" + id);
            return finalpath = (pathBBDD + "\\" + id);
        }

        private static string GetLast(string source, int tailLength)
        {
            if (tailLength >= source.Length)
                return source;
            return source.Substring(source.Length - tailLength);
        }

        /*private static byte[] GetBytes(string str)
        {
            byte[] bytes = new byte[str.Length * sizeof(char)];
            System.Buffer.BlockCopy(str.ToCharArray(), 0, bytes, 0, bytes.Length);
            return bytes;
        }*/

        public class BBDDGuti: IArchive
        {
            public BIR bir = null;
            private byte[] acBioInstance = null;
            UnitSchema unitSchema = new UnitSchema(null, bfpUUID, 0, UnitCategoryType.Archive, null, "BBDDGuti", null, null, null, null, null,
                null, null, false, 0, 0, null);

            public UnitSchema UnitSchema
            { 
                get 
                { 
                    return unitSchema; 
                } 
                set 
                { 
                    unitSchema = value; 
                } 
            }
            public byte[] ACBioInstance 
            {
                get 
                {
                    return acBioInstance;
                }
            }
            public void CloseDatabase()
            {
 
            }
            public void DeleteBIR(UUID key) 
            {

            }

            public BIR GetSingleBIR(UUID key)
            {
                string[] directories = Directory.GetDirectories(pathBBDD);
                byte[] bdbData = null;

                for (int i = 0; i < directories.Length; i++)
                {
                    if (directories[i].Substring(directories[i].Length - 4, 4) == GetLast(key.ID.ToString(), 4))
                    {
                        string pathBIR = Path.Combine(pathBBDD, GetLast(key.ID.ToString(), 4), "BIR.txt");
                        //string text = System.IO.File.ReadAllText(pathBIR);
                        //bdbData = GetBytes(text);
                        bdbData = File.ReadAllBytes(pathBIR);
                        break;
                    }
                    else { }
                }
                if (bdbData!=null)
                {
                        BIR bir = new BIR(null, 0, 0, null, false, false, BiometricType.Finger, 0, null, null, null,
                            ProcessedLevel.Raw, null, 0, 0, null, null, null, null, null, null, null, bdbData, null);
                        return bir;
                }
                else
                {
                        return null;
                        throw new BioAPIException(BioAPIException.Facility.Unit, BioAPIException.BioAPIErrBirSignatureFailure,
                            Properties.Resources.stringFailure);
                }
            }

            public List<UUID> ListUUIDs() 
            {
                string[] directories = Directory.GetDirectories(pathBBDD);
                List<UUID> listUUID = new List<UUID>();

                for (int i = 0; i < directories.Length; i++)
                {
                    string ID = directories[i].Substring(directories[i].Length - 4, 4);
                    UUID uuid = new UUID(new Guid("00000000-0000-0000-0000-00000000" + ID));
                    listUUID.Add(uuid);
                }

                return listUUID;
            }

            public IdentifyPopulation NewIdentifyPopulation() 
            {
                return null;
            }
            public IdentifyPopulation NewIdentifyPopulation(List<UUID> uuidList)
            {
                return null;
            }
            public IdentifyPopulation NewIdentifyPopulation(byte[] query)
            {
                return null;
            }
            public void OpenDatabase(byte[] databaseID, BIRDatabaseAccess access)
            {

            }

            public UUID StoreBIR(BIR biometricReference)
            {
                string path = CreateId();
                File.WriteAllBytes(Path.Combine(path, "BIR.txt"), biometricReference.BDBData);
                UUID referenceKey = new UUID(new Guid("00000000-0000-0000-0000-00000000" + GetLast(path, 4)));
                return referenceKey;
            }

            public void StoreBIR(BIR biometricReference, UUID key)
            {

            }
            public UUID StoreBIR(BIR biometricReference, byte[] auxiliaryData)
            {
                return null;
            }
            public void StoreBIR(BIR biometricReference, byte[] auxiliaryData, UUID key)
            {

            }
        }
    }
}
