﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Threading;
using BioAPI;
using BioAPI.Data;

namespace BFPSensor
{
    public class BFPSensorImplemented : IBFP
    {
        private static UUID bfpUUID = new UUID(new Guid("db1d7ca9-1984-4ac8-a2fb-3d5c4e43304b"));
        private static string path = @"..\..\..\..\BFPSensor\bin\Debug\BFPSensor.dll";
        private BFPSchema bfpSchema = new BFPSchema(bfpUUID, UnitCategoryType.Sensor, null, path, null, "BFPSensor 1.0", "GUTI", null, null, 
            null, null, null);
        private List<UnitSchema> unitlist = new List<UnitSchema>();
        private OneSensor oneSensor = new OneSensor();
        private AnotherSensor anotherSensor = new AnotherSensor();

        public BFPSchema BFPSchema
        {
            get
            {
                return bfpSchema;
            }
        }

        public void BFPEventCallback(UUID bfpUUID, int unitID, UnitSchema unitSchema, EventKind eventKind)
        {

        }

        public void BFPGUIProgressEventCallback(int unitID, string context, List<GUIBitmap> bitmaps, byte response)
        {

        }

        public void UnitAttach(int unitID)
        {

        }

        public void UnitDetach(int unitID)
        {

        }

        public void BFPLoad(BFPEventCallback bfpNotifyCallback)
        {
            //*****//
            //Here, unitlist is filled with the schemas of the units in this BFP, in this way:
            unitlist.Add(oneSensor.UnitSchema);
            unitlist.Add(anotherSensor.UnitSchema);
        }

        public List<UnitSchema> QueryUnits()
        {
            return unitlist;
        }

        public byte[] ControlUnit(int unitID, int controlCode, byte[] inputData)
        {
            return null;
        }

        class OneSensor : ISensor
        {
            GUIProgressEventCallback myCallback;
            public BIR bir = null;
            private byte[] acBioInstance = null;
            UnitSchema unitSchema = new UnitSchema(null, bfpUUID, 0, UnitCategoryType.Sensor, null, "OneSensor", null, null, null, null, 
                null, null, null, false, 0, 0, null);
            byte[] auxiliaryData = null;
            UnitIndicatorStatus indicatorStatus = 0;

            public virtual BIR Capture(List<Purpose> purpose, BiometricSubtype subtype, DataFormat outputFormat, int timeout,
                List<ResultOptions> options)
            {
                //*****//
                //Here it would come the call to Capture method from OneSensor, which gives back a byteArray with the
                //biometric information

                byte[] birArray = null;

                BIR bir = new BIR(null, 0, 0, outputFormat, false, false, BiometricType.Finger, subtype, null, null, null,
                     ProcessedLevel.Raw, null, 0, 0, null, null, null, null, null, null, null, birArray, null);

                return bir;
            }

            public void Calibrate(int timeout)
            {

            }

            public UnitSchema UnitSchema
            {
                get
                {
                    return unitSchema;
                }
                set
                {
                    unitSchema = value;
                }
            }

            public byte[] AuxiliaryData
            {
                get
                {
                    return auxiliaryData;
                }
            }

            public byte[] ACBioInstance
            {
                get
                {
                    return acBioInstance;
                }
            }

            public UnitIndicatorStatus IndicatorStatus
            {
                get
                {
                    return indicatorStatus;
                }
            }

            public void SetIndicatorStatus(UnitIndicatorStatus indicatorStatus)
            {
            }

            public void SetPowerMode(UnitPowerMode powerMode)
            {
            }

            public void SubscribeUnitToGUIEvents(GUISelectEventCallback guiSelectEventCallbackFunction, GUIStateEventCallback
                guiStateEventCallbackFunction, GUIProgressEventCallback guiProgressEventCallbackFunction)
            {
                myCallback = guiProgressEventCallbackFunction;
            }

            public void UnsubscribeUnitFromGUIEvents()
            {
                myCallback = null;
            }
        }

        class AnotherSensor : ISensor
        {
            GUIProgressEventCallback myCallback;
            public BIR bir = null;
            private byte[] acBioInstance = null;
            UnitSchema unitSchema = new UnitSchema(null, bfpUUID, 1, UnitCategoryType.Sensor, null, "AnotherSensor", null, null, null, 
                null, null, null, null, false, 0, 0, null);
            byte[] auxiliaryData = null;
            UnitIndicatorStatus indicatorStatus = 0;

            public virtual BIR Capture(List<Purpose> purpose, BiometricSubtype subtype, DataFormat outputFormat, int timeout,
                List<ResultOptions> options)
            {
                //*****//
                //Here it would come the call to Capture method from AnotherSensor, which gives back a byteArray with the
                //biometric information

                byte[] birArray = null;

                BIR bir = new BIR(null, 0, 0, outputFormat, false, false, BiometricType.Finger, subtype, null, null, null,
                     ProcessedLevel.Raw, null, 0, 0, null, null, null, null, null, null, null, birArray, null);

                return bir;
            }

            public void Calibrate(int timeout)
            {

            }

            public UnitSchema UnitSchema
            {
                get
                {
                    return unitSchema;
                }
                set
                {
                    unitSchema = value;
                }
            }

            public byte[] AuxiliaryData
            {
                get
                {
                    return auxiliaryData;
                }
            }

            public byte[] ACBioInstance
            {
                get
                {
                    return acBioInstance;
                }
            }

            public UnitIndicatorStatus IndicatorStatus
            {
                get
                {
                    return indicatorStatus;
                }
            }

            public void SetIndicatorStatus(UnitIndicatorStatus indicatorStatus)
            {
            }

            public void SetPowerMode(UnitPowerMode powerMode)
            {
            }

        }

        /*class RealScanDBFP : ISensor
        {
            GUIProgressEventCallback myCallback;
            public BIR bir = null;
            private byte[] acBioInstance = null;
            UnitSchema unitSchema = new UnitSchema(null, bfpUUID, 2, UnitCategoryType.Sensor, null, "RealScanDBFP", null, null, null, null, null,
                null, null, false, 0, 0, null);
            byte[] auxiliaryData = null;
            UnitIndicatorStatus indicatorStatus = 0;

            private int deviceHandle = 0;
            private int numDedos;

            public RealScanDBFP(bool numDedos)
            {
                if (numDedos) this.numDedos = 1;
                if (!numDedos) this.numDedos = 3;
                int numOfDevice = 0;

                int result = RealScanSDK.RS_InitSDK(null, 0, ref numOfDevice);

                if (result != RealScanSDK.RS_SUCCESS)
                {
                    MessageBox.Show("Error al inicializar el SDK " + result, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

                result = RealScanSDK.RS_InitDevice(0, ref deviceHandle);

                if (result != RealScanSDK.RS_SUCCESS)
                {
                    MessageBox.Show("Error al inicializar el dispositivo " + result, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }

            public virtual BIR Capture (List<Purpose> purpose, BiometricSubtype subtype, DataFormat outputFormat, int timeout,
                List<ResultOptions> options)
            {
                int holaquetal = 0;
                RealScanSDK.RS_InitSDK(null, 0, ref holaquetal);
                RealScanSDK.RS_InitDevice(0, ref holaquetal);

                int result = RealScanSDK.RS_SetCaptureMode(deviceHandle, numDedos, 0, true);

                int imageWidth = 0;
                int imageHeight = 0;
                IntPtr imageData = (IntPtr)0;
                RealScanSDK.RS_RemoveAllOverlay(deviceHandle);
                result = RealScanSDK.RS_TakeImageData(deviceHandle, timeout, ref imageData, ref imageWidth, ref imageHeight);

                #region Errors
                if (result != RealScanSDK.RS_SUCCESS)
                {
                    RealScanSDK.RS_ExitAllDevices();
                    if (result == -202)
                    {
                        MessageBox.Show("Timeout de dedo", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -115)
                    {
                        MessageBox.Show("Sensor muy sucio", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -116)
                    {
                        MessageBox.Show("Dedo presente antes de activar el sensor", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -208)
                    {
                        MessageBox.Show("Gire más despacio el dedo ", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -209)
                    {
                        MessageBox.Show("No rote el dedo ", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -211)
                    {
                        MessageBox.Show("Problema en la dirección de giro ", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -214)
                    {
                        MessageBox.Show("Huella muy corta ", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    if (result == -215)
                    {
                        MessageBox.Show("No se puede segmentar ", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        if (imageData != (IntPtr)0)
                        {
                            RealScanSDK.RS_FreeImageData(imageData);
                        }
                        return null;
                    }
                    MessageBox.Show("Error : " + result, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);

                    if (imageData != (IntPtr)0)
                    {
                        RealScanSDK.RS_FreeImageData(imageData);
                    }
                    return null;
                }
                #endregion

                string path = Application.StartupPath;
                path = path + "\\prueba__xx.bmp";

                path = System.IO.Path.GetTempFileName();
                result = RealScanSDK.RS_SaveBitmap(imageData, imageWidth, imageHeight, path);

                System.Drawing.Bitmap bmp = new System.Drawing.Bitmap(path);
                byte[] aux = File.ReadAllBytes(path);
                RealScanSDK.RS_FreeImageData(imageData);
                RealScanSDK.RS_ExitAllDevices();

                BIR bir = new BIR(null, 0, 0, outputFormat, false, false, BiometricType.Finger, subtype, null, null, null,
                0, null, 0, 0, null, null, null, null, null, null, null, aux, null);

                return bir;
            }

            public byte[] ControlUnit(int ControlCode, byte[] InputData)
            {
                return null;
            }

            public void Calibrate(int timeout)
            {

            }

            public UnitSchema UnitSchema
            {
                get
                {
                    return unitSchema;
                }
                set
                {
                    unitSchema = value;
                }
            }

            public byte[] AuxiliaryData
            {
                get
                {
                    return auxiliaryData;
                }
            }

            public byte[] ACBioInstance
            {
                get
                {
                    return acBioInstance;
                }
            }

            public UnitIndicatorStatus IndicatorStatus
            {
                get
                {
                    return indicatorStatus;
                }
            }

            public void SetIndicatorStatus(UnitIndicatorStatus IndicatorStatus)
            {
            }

            public void SetPowerMode(UnitPowerMode PowerMode)
            {
            }

            public void SubscribeUnitToGUIEvents(GUISelectEventCallback GUISelectEventCallbackFunction, GUIStateEventCallback
                GUIStateEventCallbackFunction, GUIProgressEventCallback GUIProgressEventCallbackFunction)
            {
                myCallback = GUIProgressEventCallbackFunction;
            }

            public void UnsubscribeUnitFromGUIEvents()
            {
                myCallback = null;
            }
        }*/

        /*class EikonBFP : ISensor
        {
            GUIProgressEventCallback myCallback;
            public BIR bir = null;
            private byte[] acBioInstance = null;
            UnitSchema unitSchema = new UnitSchema(null, bfpUUID, 1, UnitCategoryType.Sensor, null, "EikonBFP", null, null, null, null, null,
                null, null, false, 0, 0, null);
            byte[] auxiliaryData = null;
            UnitIndicatorStatus indicatorStatus = 0;

            int w;
            int h;

            public virtual BIR Capture(List<Purpose> purpose, BiometricSubtype subtype, DataFormat outputFormat, int timeout,
                List<ResultOptions> options)
            {
                byte[] birArray = null;

                try
                {
                    uint w1 = (uint)0;
                    uint h1 = (uint)0;
              
                    unsafe
                    {
                        byte* t = new Class1().CapturaImagen(&w1, &h1, 40000);

                        birArray = new byte[w1 * h1];
                        if (birArray.Length == 0)
                        {
                            return null;
                        }
                        for (int i = 0; i < 270 * 186; i++)
                        {
                            birArray[i] = *(t + i);
                        }

                    }
                    w = (int)w1;
                    h = (int)h1;

                }
                catch (Exception) { return null; }

                BIR bir = new BIR(null, 0, 0, outputFormat, false, false, BiometricType.Finger, subtype, null, null, null,
                0, null, 0, 0, null, null, null, null, null, null, null, birArray, null);

                return bir;
            }

            private System.Drawing.Bitmap DrawImage(byte[] imgData)
            {
                int colorval;
                Bitmap bmp = new Bitmap(w, h);

                for (int i = 0; i < bmp.Width; i++)
                {
                    for (int j = 0; j < bmp.Height; j++)
                    {
                        colorval = (int)imgData[(j * w) + i];
                        bmp.SetPixel(i, j, Color.FromArgb(colorval, colorval, colorval));
                    }
                }

                return bmp;
            }

            public byte[] ControlUnit(int ControlCode, byte[] InputData)
            {
                return null;
            }

            public void Calibrate(int timeout)
            {

            }

            public UnitSchema UnitSchema
            {
                get
                {
                    return unitSchema;
                }
                set
                {
                    unitSchema = value;
                }
            }

            public byte[] AuxiliaryData
            {
                get
                {
                    return auxiliaryData;
                }
            }

            public byte[] ACBioInstance
            {
                get
                {
                    return acBioInstance;
                }
            }

            public UnitIndicatorStatus IndicatorStatus
            {
                get
                {
                    return indicatorStatus;
                }
            }

            public void SetIndicatorStatus(UnitIndicatorStatus IndicatorStatus)
            {
            }

            public void SetPowerMode(UnitPowerMode PowerMode)
            {
            }

            public void SubscribeUnitToGUIEvents(GUISelectEventCallback GUISelectEventCallbackFunction, GUIStateEventCallback
                GUIStateEventCallbackFunction, GUIProgressEventCallback GUIProgressEventCallbackFunction)
            {
                myCallback = GUIProgressEventCallbackFunction;
            }

            public void UnsubscribeUnitFromGUIEvents()
            {
                myCallback = null;
            }
        }*/

    }
}
