﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BioAPI.Data
{
    public class BFPListElement
    {
        /// <summary>
        /// Identifies a BFP by category and UUID. A list is returned by a BSP when queried for the installed BFPs that it supports.
        /// UnitCategory is the category of the unit, and BFPID is the UUID assigned to the BFP.
        /// </summary>
        
        public UnitCategoryType UnitCategory { get; set; }
        public UUID BFPID { get; set; }

        public BFPListElement(UnitCategoryType unitCategory, UUID bfpID)
        {
            UnitCategory = unitCategory;
            BFPID = bfpID;
        }
    }
}
