﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BioAPI.Data
{

    /// <summary>
    /// Represents <i>False Compare Rate</i> - a 32-but integer value (N) that indicates a probable False Compare Rate of 
    /// N/(231-1). The larger the value, the worse the result. Negative values are used to signal exceptional 
    /// conditions. The only negative value currently defined is minus one.
    /// For security reasons no methods to modify the exisitng FCR object are procided. Instead, an application 
    /// should use the corresponding method of the DataFactory to create new FCR containing modified data.
    /// </summary>
    /// <author>
    /// See CREDITS.txt
    /// </author>
    public interface IFCR
    {
        int FalseCompareRate
        {
            get;
        }
    }
}
