﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BioAPI.Data
{

    /// <summary>
    /// Represents the record in the component registry that defines properties of the implementation of the biometric system.
    /// For security reasons no methods to modify the existing FrameworkSchema object are provided.
    /// </summary>
    /// <author>
    /// See CREDITS.txt
    /// </author>
    public class FrameworkSchema
    {
        public UUID FrameworkUUID { get; private set; }
        public string FwDescription { get; private set; }
        public string Path { get; private set; }
        public string SpecVersion { get; private set; }
        public string ProductVersion { get; private set; }
        public string Vendor { get; private set; }
        public UUID FwPropertyID { get; private set; }
        public byte[] FwProperty { get; private set; }

        public FrameworkSchema(UUID frameworkUUID, string fwDescription, string path, string specVersion, string productVersion, string vendor,
            UUID fwPropertyID, byte[] fwProperty)
        {
            FrameworkUUID = frameworkUUID;
            FwDescription = fwDescription;
            Path = path;
            SpecVersion = specVersion;
            ProductVersion = productVersion;
            Vendor = vendor;
            FwPropertyID = fwPropertyID;
            FwProperty = fwProperty;
        }
    }
}
