﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BioAPI.Data;

namespace BioAPI.Data
{

    /// <summary>
    /// Represents the collection of BIRs the compare takes place against on biometric identification. The population can be presented in one of two ways:
    /// In a BIR database. Such population is defined via the Archive.NewIdentifyPopulation(string).
    /// In a collection of BIRs. Such population is created via the DataFactory.NewIdentifyPopulation(Collection).
    /// No methods to modify the existing IdentifyPopulation object are provided. Instead, an application should use the corresponding method of
    /// the DataFactory to create new IdentifyPopulation containing modified data.
    /// </summary>
    /// <author>
    /// See CREDITS.txt
    /// </author>
    public class IdentifyPopulation
    {
        public List<PopulationMember> PopulationIdentified { get; private set; }

        public IdentifyPopulation(List<PopulationMember> populationIdentified)
        {
            PopulationIdentified = populationIdentified;
        }

        public void AddMember(PopulationMember member)
        {
 
        }

        public void Destroy()
        {
 
        }

        /// <returns>
        /// true if at least one BIR in the population is bound to the BSP
        /// </returns>
        public bool IsBound()
        {
            return true;
        }

        /// <summary>
        /// Ensures that all member BIRs are unbound.
        /// </summary>
        public void Unbind()
        {
 
        }
    }
}
