﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BioAPI.Data
{
    public class SecurityProfileType
    {
        public List<SecurityOptionsType> SupportedSecurityOptions { get; private set; }
        public byte[] ENCInfo { get; private set; }
        public byte[] MACInfo { get; private set; }
        public byte[] SIGNAlg { get; private set; }
        public List<BSPSchemaOptions> ACBioOption { get; private set; }
        public byte[] HASHAlgForACBio { get; private set; }
        public byte[] MACInfoForACBio { get; private set; }
        public byte[] SIGNAlgForACBio { get; private set; }

        public SecurityProfileType
            (List<SecurityOptionsType> supportedSecurityOptions, byte[] encInfo, byte[] macInfo, byte[] signalG, 
            List<BSPSchemaOptions> acBioOption, byte[] hashalGForACBio, byte[] macInfoForACBio, byte[] signalGForACBio)
        {
            SupportedSecurityOptions = supportedSecurityOptions;
            ENCInfo = encInfo;
            MACInfo = macInfo;
            SIGNAlg = signalG;
            ACBioOption = acBioOption;
            HASHAlgForACBio = hashalGForACBio;
            MACInfoForACBio = macInfoForACBio;
            SIGNAlgForACBio = signalGForACBio;
        }
    }
}
