﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BioAPI.Data;

namespace BioAPI
{
    /// <summary>
    /// Interface for attached Archive units.
    /// </summary>
    /// <author>
    /// See CREDITS.txt
    /// </author>
    public interface IArchive
    {
        UnitSchema UnitSchema { get; }
        byte[] ACBioInstance { get; }

        void CloseDatabase();
        void DeleteBIR(UUID key);
        BIR GetSingleBIR(UUID key);
        List<UUID> ListUUIDs();
        IdentifyPopulation NewIdentifyPopulation();
        IdentifyPopulation NewIdentifyPopulation(List<UUID> uuidList);
        IdentifyPopulation NewIdentifyPopulation(byte[] query);
        void OpenDatabase(byte[] databaseID, BIRDatabaseAccess access);
        UUID StoreBIR(BIR biometricReference);
        void StoreBIR(BIR biometricReference, UUID key);
        UUID StoreBIR(BIR biometricReference, byte[] auxiliaryData);
        void StoreBIR(BIR biometricReference, byte[] auxiliaryData, UUID key);
    }
}
