﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BioAPI.Data;

namespace BioAPI
{
    /// <summary>
    /// Represents the interface to the component registry. The Installer adds deletes
    /// of modifies BSP and BFP records in the component registry managed by the framework.
    /// </summary>
    /// <author>
    /// See CREDITS.txt
    /// </author>
    public interface IComponentRegistry
    {
        void InstallBFP(BFPSchema bfpSchema, bool update);
        void InstallBSP(BSPSchema bspSchema, bool update);
        void UninstallBFP (UUID bfpUUID);
        void UninstallBSP(UUID bspUUID);
    }

}
