﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BioAPI.Data
{

    /// <summary>
    /// Represents the payload the application can associate with the biometric template. For security reasons no methods to modify the
    /// existing Payload object are provided. Instead, an application should use the corresponding method of the DataFactory to create new
    /// Payload containing modified data.
    /// </summary>
    /// <author>
    /// See CREDITS.txt
    /// </author>
    public interface IPayload
    {
        byte[] DataPayload { get; set; }
    }


}
